/**
 *
 * Description : A class that extends SSOAcctMngtSignOutController  
 * <p>
 * Filename    : SSOAcctMngtRememberMeControlle.js
 * <p>
 * Part of     : Controllers
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @version %version:   9 %
 * @class SSOAcctMngtRememberMeController
 * @name SSOAcctMngtRememberMeController 
 */

ovi.provide( 'ssoui.controllers.SSOAcctMngtSignOutController' );
ovi.require( 'ssoui.controllers.SSOViewController' );
ovi.require( 'ssoui.utils.SSOConstant',false )
ovi.require( 'ssoui.ui.SSOUIHelper');
ovi.require( 'ssoui.ui.SSOError');
ovi.declare( 'ssoui.controllers.SSOAcctMngtSignOutController',{
    
    /**
     * SSOAcctMngtSignOutController extends the SSOViewController class.
     * @extends ssoui.controllers.SSOViewController
     */
    Extends: ssoui.controllers.SSOViewController,
    
    /**
     * Creates the objects needed for this controller
      * Gets the view and model for the RememberMe
     * @function initialize
     */
    initialize: function() {
        this._super();        
        //Get the view to be displayed
        this.view  = this.getView();         
        //Get the signin model to get and store the data
        this.model = this.getModel('SSOSignIn');    
    },
    
   /**
     * Activate the view     
     * @function activate
     */
    activate: function() {         
        // Dispaly the main setting screen.
        this.view.render();
        this.model = this.getModel('SSOSignIn')
    },
    
    /**
     * Subscribe for the navigation events - Next/back/Cancel 
     * @function subscribers
     */
    subscribers: {
        "rememberMeSettings" : function(){
			//@TODO: CR: HIGH: Private method. Use Prefix "_"
                //Move to the SignIn API call                 
                this.setRememeberMeSettings();
        },
        "rememberMeSettingsNotChanged" : function(){
			//@TODO: CR: HIGH: WHy not to use this.moveback();
            // return back to previous screen
            this.applicationController.activate('SSOAccountManagement');
        }
    }, 
   
    
    /**
     * Triggered when cancel is pressed in Account Management Screen
     * Move to the account management screen
     * @function moveback
     */
    moveback: function() {   
        //Should load the account management view when we click on Cancel
        this.applicationController.activate('SSOAccountManagement'); 
    },
    
    
    /**
     * Destroys the view when deactivate is called
     * @function closeApplication     
     */
    deactivate: function() {                   
        // Destroy the view
        this.view.destroy();
    }    
});