/**
 *
 * Description : A class that extends SSOViewController
 *               Maintains the wizard for the signin usecase 
 * <p>
 * Filename    : SSOTOSController.js
 * <p>
 * Part of     : Controllers
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @class SSOTOSController
 * @name SSOTOSController 
 */
 
 ovi.provide('ssoui.controllers.SSOParentInfoController');
 ovi.require('ssoui.controllers.SSOViewController');
 ovi.require( 'ssoui.utils.SSOConstant',false );
 ovi.require( 'ssoui.utils.SSOUtil', false);
 ovi.declare('ssoui.controllers.SSOParentInfoController', {
 
  /**
  * TOSController extends the SSOViewController class.
  * @extends ssoui.controllers.SSOViewController
  */
  Extends: ssoui.controllers.SSOViewController,
  
  /**
  * Creates the objects needed for this controller
  * Calls the base class init function which initiliazes the noa objects needed
  * @function initialize
  */
  initialize: function() {
    this._super();
    //Get the view to be displayed
    this.view  = this.getView();
  },
  
  /**
  * Activate the view	 
  * @function activate
  */
  activate: function() {    
    // Dispaly the Terms of Services view with the status values
    this.view.render();
  },	
  
  /**
  * Destroys the view when deactivate is called
  * @function deactivate	 
  */
  deactivate: function() {   				
    // Destroy the view
    this.view.destroy();
  }	
 });
 
