/**
 *
 * Description : A controller class for SSOParentConsentView
 *  
 * <p>
 * Filename    : SSOParentalConsentController.js
 * <p>
 * Part of     : Controllers
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @version %version:   4.2.1 %
 * @class SSOParentalConsentController
 * @name SSOParentalConsentController 
 */

ovi.provide('ssoui.controllers.SSOParentalConsentController');
ovi.require('ovi.sisu.Controller');
ovi.require('ssoui.utils.SSOConstant',false);
ovi.require('ssoui.utils.SSOUtil',false);
ovi.declare('ssoui.controllers.SSOParentalConsentController',{
    
    /**
     * SSOParentalConsentController extends the ovi.sisu.Controller class.
     * @extends ovi.sisu.Controller
     */
    Extends: ovi.sisu.Controller,
    
    /**
     * Creates the objects needed for this controller
     * Calls the base class init function which initiliazes the noa objects needed
     * @function initialize
     */
    initialize: function() {
		//console.log("Inside SSOParentSignUpController init");
        this._super();
        //Get the view to be displayed
        this.view  = this.getView(); 
        //Get the signin model to get and store the data
        this.model = this.getModel("SSOParentSignUp");    
    },
    
   /**
     * Activate the view     
     * @function activate
     */
    activate: function() {
    	//console.log("inside SSOParentSignUpController activate");        
    	this.view.render();
    },
    
    /**
	 * Destroys the view when deactivate is called
	 * @function closeApplication	 
	 */
    deactivate: function() {
    	//console.log("inside SSOParentSignUpController deactivate");
        // This patch is done because, this._domNode is the property which is set when we call/override
        // render function. Now when isauthenticated is true, i.e when we launch 'Sign in' second after
        // a successful sign in, then isauthenticated will be 'true'. In that case we are just calling 
        // Sign in API which in turn calls TOS View if there is an updation of any of the TOS' in the backend.
        // When we do 'activate' of TOS view, it internally calls the 'deactivate' of the current view(SSOSIGNIN view)
        // Since we have not rendered the view, this._domNode is not defined, it will result in a JS error, thus by checking
        // for this._domNode we are making sure, view.destroy() works in all the cases. (for more info, refer htmlview.js in ovi library)
        if(this.view._renderer){   				
          // Destroy the view
          this.view.destroy();
        }
    },
    
    /**
     * Subscribe for the navigation events - Next/back/Cancel 
     * @function subscribers
     */
    subscribers: {
        //@TODO: CR: MEDIUM: Remove below dead code 
        /*"movenext" : function(){
                //Move to the SignIn API call                 
                this.movenext(); 
        },
        "moveback" : function(){
                //Cancel has been trigerred. Close the application
                //As the RSK for the signin usecase is always Cancel
                // post the event to clients so that they can know the status of signin, if they are intrested.
                var eventMessageObj= this.applicationController.getEventMessageObj();
                eventMessageObj.post(this.applicationController.settings.get('ssoUIContext'),SSOUtil.convertToJSONFormat(SSOConstant.Error,SSOConstant.Cancelled));
                this.closeApplication();
        }*/        
    }
	
});