/**
 *
 * Description : A class that extends ovi.sisu.Model
 *               Maintains the wizard for the signin usecase 
 * <p>
 * Filename    : SSOSignInModel.js
 * <p>
 * Part of     : Model
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @version %version:   6 %
 * @class SSOSignInController
 * @name SSOSignInController 
 */
 
//@TODO: CR: MEDIUM: File header description is not in sync with ParentSignUp 
ovi.provide('ssoui.models.SSOParentSignUpModel');
ovi.require('ovi.sisu.Model');
ovi.require('ssoui.utils.SSOConstant',false)
ovi.declare('ssoui.models.SSOParentSignUpModel', {
    
	//@TODO: CR: MEDIUM: Below documentation is wrong
    /**
     * SSOSignInModel extends the SSOSignInModel class.
     * @extends ovi.sisu.SSOSignInModel
     */
    Extends: ssoui.models.SSOSignUpModel,
    
    /**     
     * Init the base class
     * @function initialize
     */
    initialize: function() {
        this._super();
    },
    
	//@TODO: CR: HIGH: Document declaration of call-back 
    /**
     * 
     * @function signInAsGuardian
     */
    signInAsGuardian: function(aCallback, aContext) { 
        this._callback = aCallback;
        this._context = aContext;
        this._regobj = this.applicationController.getRegObj();
		try {
			this._regobj.signInAsGuardian( this._signInAsGuardianCompleted, this.password, this.username, this);
		} catch(ex) {
			ovi.error("Exception occured while doing guardian sign-in - "+ ex.message);
			this._callback(SSOConstant.Failure, ErrorCode.errorGeneralError, this._context);
		}
    },
    
    /**     
     * Callback API when the signin is completed
     * Enabler object calls this API when the signin request is completed
     * @param {var} aError - error code of the request
     * @param {var} aType - request type
     * @param {var} aRequestId - request id
     * @param {object} aContext - this pointer
     */
    _signInAsGuardianCompleted: function(aError, aType, aRequestId, aContext) {
        if(aError == ErrorCode.errorNone || aError == ErrorCode.errorAccountNotActivated) {
            //Send the request as success 
            aContext._callback(SSOConstant.Success,aError,aContext._context);
        } else {
            aContext._callback(SSOConstant.Failure,aError,aContext._context);
        }
    },
    
	//@TODO: CR: HIGH: Below method is not private. It is called by other
	//     classes. Make it public. Remove prefix "_"
	//     Secondly, why do we need this method? As we are not having any
	//     data stored in this view.
    /**
     * clears all the stored values
     * @function _clear
     */
    _clear: function() {
    	this._super();
    }
});