/*
 * Copyright (C) 2009, Nokia gate5 GmbH Berlin
 *
 * These coded instructions, statements, and computer programs contain
 * unpublished proprietary information of Nokia gate5 GmbH, and are
 * copy protected by law. They may not be disclosed to third parties
 * or copied or duplicated in any form, in whole or in part, without
 * the specific, prior written permission of Nokia gate5 GmbH.
 */
//@TODO: CR: Do not find usage of this snippet control anywhere in
//our code. Remove them.
ovi.provide("ssoui.ui.SSOBusyIndicator");

ovi.require('ovi.dom');
ovi.require("ovi.ui.Control");

/**
 * A SSOBusyIndicator is a control that shows visual progress based on the action.
 *
 * @publish
 * @class
 * @name ssoui.ui.SSOBusyIndicator
 * @param {Object} [aProperties={}] The properties object that will be used to configure ProgressBar component on
 *         initialization. Can contain following fields:
 * @param {DOM Node} [aPlacement] The DOM node element where the component will be placed.
 * @param {string} [aPosition="last"] Relative position to the reference node {@link ovi.ui.Snippet#place}.
 */
ssoui.ui.SSOBusyIndicator = new ovi.Class({
	
    Extends: ovi.ui.Control,

    /**
     * The default template for the busy indicator. Will be used to create the DOM nodes.
     */
    template: '<div class="SSOBusyIndicator"><img src="./images/loader_grey_30px_exact.gif" /></div>',

    /**
     * 
     * @function initialize
     */
    initialize : function(aProperties, aPlacement) {
		this._super(aProperties, aPlacement);
    },
    
    /**
     * shows the busy indicator
     * @function show
     */
    show: function() {
    	this.setProperty("hidden", false);
    },

    /**
     * hides the busy indicator
     * @function hide
     */
    hide: function() {
    	this.setProperty("hidden", true);
    }
});
