 ovi.provide("ssoui.ui.SSORadioGroupDialog");
 
 ovi.require("ovi.ui.RadioGroup");
 ovi.require("ovi.ui.Snippet");

ssoui.ui.SSORadioGroupDialog = new ovi.Class({
    Extends: ovi.ui.Snippet,
    Statics: {
        CLOSE_EVENT: "closed"
    },
    template: '<div class="sso_Dialog ovi_modal sso_RadioDialog">' +
                '<div class="sso_DialogArea">' +
                '<div class="sso_DialogTitlebar">' +
                  '<div data-bind-text="titlemessage"></div></div>' +
                 '<div class="sso_DialogHeading">' + 
                 '<div data-bind-text="headingmessage"></div></div>' + 
                  '<div data-bind-ref="rg"></div>' +
                  '<div class="sso_DialogButtonArea">' +
                  '<div data-bind-snippet="ovi.ui.Button:cancelButton" data-bind-prop="text:cancel"></div></div>' +
               '</div></div>',
              
/**
     * Default label for the cancel button.
     *
     * @type String
     */
    cancel: sso_button_sk_cancel,
              
    build: function () {
        this._super.apply(this, arguments);
        
        var that = this, 
                                            
        rg = new ovi.ui.RadioGroup({
            labels: this.labels
        }, this.rg);
        
        // BUG fixed in week 13, e.data.selected.label was deprecated after ovijs release week 12
        // Now we are using e.data.selected.getProperty("text") instead, refer https://saeljira01.ext.nokia.com/browse/OVIJS-47
        // for more details
        
        rg.addEventHandler("selected", function (e) {
            setTimeout(function () {
                that.fireEvent({
                    type: that.constructor.CLOSE_EVENT,
                    data: e.data.selected.getProperty("text")
                });
                that.destroy();
            }, 300);
        });
        
        this.cancelButton.addEventHandler(ovi.ui.Button.CLICK_EVENT, function (e) {
            that._close(false);
        });
    },
    
    /**
     * Event listener for the DOM click event of the buttons. This handler will fire the custom 'close' event.
     *
     * @param {Event} e the received DOM event
     * @see ovi.ui.Dialog#fireEvent:close
     * @see ovi.ui.Dialog.CLOSE_EVENT
     */
    _close: function (confirm) {
        var that = this;
        setTimeout(function () {
            that.fireEvent({
                type: that.constructor.CLOSE_EVENT,
            });
            that.destroy();
        }, 300);
    }
});
