/*
 * Copyright (C) 2009, Nokia gate5 GmbH Berlin
 *
 * These coded instructions, statements, and computer programs contain
 * unpublished proprietary information of Nokia gate5 GmbH, and are
 * copy protected by law. They may not be disclosed to third parties
 * or copied or duplicated in any form, in whole or in part, without
 * the specific, prior written permission of Nokia gate5 GmbH.
 */

ovi.provide("ssoui.ui.SSOSoftKey");

ovi.require("ovi.ui.Button");

/**
 * Button UI Control.
 *
 * @example
 * // Example
 * var button = new ovi.ui.Button({ text: "" }, document.body); // Button label is empty yet
 * button.setProperty("text", "Button"); // Button now says "Button"
 *
 * @publish
 * @param {Object} properties A hash with properties for the snippet.
 * @param {String} properties.text The button's text.
 * @param {Node} [placement] Placement node that defines the place for snippet.
 * @param {String} [position] Relative position of the snippet to the placement node. See {@link ovi.ui.Snippet#place}.
 */
ssoui.ui.SSOSoftKey = new ovi.Class({
     Extends: ovi.ui.Button,
     
    initialize : function(aProperties,aPlacement ) {
		this._super(aProperties, aPlacement);
        this._root.className = "sso_Softkey sso_unselectable";
    }    
    
});
