/*
 * Copyright (C) 2009, Nokia gate5 GmbH Berlin
 *
 * These coded instructions, statements, and computer programs contain
 * unpublished proprietary information of Nokia gate5 GmbH, and are
 * copy protected by law. They may not be disclosed to third parties
 * or copied or duplicated in any form, in whole or in part, without
 * the specific, prior written permission of Nokia gate5 GmbH.
 */

ovi.provide("ssoui.ui.SSOSpinner");

ovi.require('ovi.dom');
ovi.require("ovi.ui.Snippet");
ovi.require("ovi.ui.Control");
ovi.require('ovi.ui.Spinner');

/**
 * A progress bar is a control that shows visual progress based on the actual and maximum progress.
 *
 * @publish
 * @class
 * @name ovi.ui.ProgressBar
 * @param {Object} [aProperties={}] The properties object that will be used to configure ProgressBar component on
 *         initialization. Can contain following fields:
 * @param {number} [value=0.0] The initial value of the overall progress.
 * @param {number} [maximum=1.0] The maximum value of the overall progress.
 * @param {DOM Node} [aPlacement] The DOM node element where the component will be placed.
 * @param {string} [aPosition="last"] Relative position to the reference node {@link ovi.ui.Snippet#place}.
 */
ssoui.ui.SSOSpinner = new ovi.Class({
	
    Extends: ovi.ui.Control,

    /**
     * The default template for the progress bar. Will be used to create the DOM nodes.
     */
    template: '<div class="ssoSpinner"><div class="ovi_modal"><div class="ssoSpinnerContainer"><div data-bind-snippet="ovi.ui.Spinner:sso_Spinner"></div></div></div></div>',
    
    /**
     * Init function of the progress control.
     * @function initialize
     */
    initialize : function(aProperties, aPlacement) {
		this._super(aProperties, aPlacement);
    }
});
