/**
 *
 * Description : A static class (Javascript object) that maintains a set of
 * properties within the wrtkit framework.  It is used to hold variables that 
 * should be available for all the classes in the framework.
 * <p>
 * Filename    : SSOConstant.js
 * <p>
 * Part of     : UI Framework
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * 
 * @example
 * SSOConstant.Success
 * 
 * @version %version:  5.1.1 %
 *
 */

/**
 * #@+
 * @memberOf ovi.serviceui.ssoui.ssoui
 */

var SSOConstant = {
        Success : true,
        Failure : false,
        Error   : "Error",
        Completed: "Completed",
        Cancelled : "Cancelled",
        SignInCompleted: "SignedIn",
        SignUpCompleted : "AccountCreated",
        SignIn : "SSO.SignIn",
        SignUp : "SSO.AccountCreation",
        AccountManagement: "SSO.AccountManagement",
        SignInContext   : "NOA_SSO_HLP_SIGNIN",
        SignUpContext   : "NOA_SSO_HLP_SIGNUP",
        PasswdRecovContext: "NOA_SSO_HLP_PWDRECOVERY",
        AccMgtContext   : "NOA_SSO_HLP_NOAMGMT",
        Exit            : "Exit"
};

/**
 * SSOOrientation is an enumeration to identify the orientation
 * @values Landscape, Portrait
 */
var SSOOrientation = {
	Landscape: 1,
	Portrait: 2
}
