/**
 *
 * Description : A class that extends ssoui.views.SSOWizardView
 *               A page which contains the user details for account creation.
 * <p>
 * Filename    : SSOAboutYouView.js
 * <p>
 * Part of     : View
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @version %version:   31.3.3 %
 * @class SSOAboutYouView
 * @name  SSOAboutYouView 
 */

ovi.provide('ssoui.views.SSOAboutYouView');
// system includes
ovi.require('ovi.sisu.HTMLView');
ovi.require('ovi.ui.Button');
ovi.require('ovi.ui.Label');
ovi.require('ovi.ui.TextInput');
ovi.require('ovi.ui.DropDown');
//ovi.require("ssoui.ui.SSOTumblerButton");
ovi.require("ovi.ui.Tumbler");
ovi.require("ovi.ui.DatePicker");
ovi.require("ovi.themes");
ovi.require("ovi.i18n");
// local includes
ovi.require('ssoui.views.SSOWizardView');
ovi.require('ssoui.ui.SSOTextInput');
ovi.require('ssoui.ui.SSOMobileInput');
ovi.require('ssoui.ui.TextLink');
ovi.require('ssoui.ui.SSOPasswordInput'); 
ovi.require('ssoui.utils.SSOUtil',false);
ovi.require('ssoui.ui.SSODateControl')
ovi.require( 'ssoui.services.SSOCountryName', false );

ovi.declare('ssoui.views.SSOAboutYouView', {
    
    Extends: ssoui.views.SSOWizardView,
    
	//@TODO: CR: MEDIUM: Document function description block 
    initialize: function() {        
        this._super(sso_signup_title, sso_signup_header_accountdetails, 
		{
			text: sso_button_sk_finish,
			type: "affirmative"
		}, 
		{
			text: sso_button_sk_back
		});
    },
    
    //@TODO: CR: MEDIUM: Document function description block 
    render: function(aModel) {
    	ovi.debug('inside SSOAboutYouView render');
    	
    	var _isParentSignup = this.settings.get('isParentSignUp');
        if(_isParentSignup) {
            this.model = this.getModel("SSOParentSignUp");            
        } else {
            this.model = this.getModel("SSOSignUp");
        }
    	
    	this._super();
      
        this._dobLabel = new ovi.ui.Label( { text: sso_signup_label_dob }, this.element1);
        this._dobLabel._root.className = "sso_field_Label";
        this._dobField = new ssoui.ui.SSODateControl({text: ""}, this.element1);
        this._dobInfoLabel = new ovi.ui.Label({}, this.element1);
        
        this._mobileNumberField = new ssoui.ui.SSOMobileInput({
			"headerLabel":sso_signup_label_mobilenumber,
			"infoLabel":sso_signup_label_mobilenoformat
		}, this.element2);
        
        // Display the marketing consent Checkbox/Label		
		var marketingconsentvalue = this.model.getConsentValue();
		this.showMarketingConsentCheckbox(marketingconsentvalue);
		
		// First textlink  
    	this._toslink0 = new ovi.ui.Label({ text: sso_signup_label_oviserviceterms0}, this.viewContainer);
      	this._toslink0._root.style.display = "inline";
      	
		// First textlink  
    	this._toslink1 = new ovi.ui.TextLink({ text: sso_signup_textlink_oviserviceterms1}, this.viewContainer);
      	this._toslink1._root.style.display = "inline";                    
      	this._toslink1.addEventHandler("selected", function() {
          //ovi.publish('toslink');
          //this._openTOSLink();
        }, this);
      
        // Second textlink
        this._toslink2 = new ovi.ui.TextLink({ text: sso_signup_textlink_oviserviceterms2}, this.viewContainer);
        this._toslink2._root.style.display = "inline";                
        this._toslink2.addEventHandler("selected", function() {
        	//ovi.publish('servicespecifictoslink');
        	//this._openServiceSpecificTOSLink();
        }, this);
        
        // Label 'and'
        this._andtextlabel = new ovi.ui.Label({ text: sso_signup_label_oviserviceterms3 }, this.viewContainer);
        this._andtextlabel._root.style.display = "inline"; 
            
        // Third textlink
        this._toslink3 = new ovi.ui.TextLink({ text: sso_signup_textlink_oviserviceterms4 }, this.viewContainer);
        this._toslink3._root.style.display = "inline";        
        this._toslink3.addEventHandler("selected", function() {
        	//ovi.publish('privacypolicylink');
        	//this._openPrivacyPolicyLink();
        }, this);
		
        this._dobField.setValue(this.model.getDOB());
	    this._mobileNumberField.setProperty("countryCode", this.model.getCountry());
	    this._mobileNumberField.setProperty("mobileNumber", this.model.getMobilenumber());        
        
        ovi.debug('SSOAboutYouView rendering complete');
    },
    
	/**
	 * This function displays a Checkbox/Label based on the marketing consent
	 * value retrieved when "Create Nokia Account" Button was clicked in
	 * SSOSignUpView.js
     * @function showMarketingConsentCheckbox
     * @param {object} aError This object contains the error info
     */
	showMarketingConsentCheckbox: function(aMarketingConsentInfo) {
		
		switch(aMarketingConsentInfo) {
			// Implicit consent case, Just display a label
			case ConsentQueryVariant.QueryVariantImplicit:
				this._marketingConsent = 
				new ovi.ui.Label({text: sso_signup_label_smc01}, this.element3)
			    break;
				
			case ConsentQueryVariant.QueryVariantPreTicked:
			// Pre ticked Checkbox
			     this._marketingConsent = new ovi.ui.CheckBox(
                {text: sso_signup_label_smc02, checked: true}, 
                this.element3);
			    break;
				
			case ConsentQueryVariant.QueryVariantUnTicked:
			// un ticked checkbox
			     this._marketingConsent = new ovi.ui.CheckBox(
                {text: sso_signup_label_smc02, checked: false}, 
                this.element3);
			    break;
				
			case ConsentQueryVariant.QueryVariantUnTickedWithCopyText:
			// For US / Canada, we show a preticked checkbox with different 
			// checkbox label (With respect to above 2 cases)
                 this._marketingConsent = new ovi.ui.CheckBox(
                {text: sso_signup_label_smc03, checked: true}, 
                this.element3);
                break;
		}
		
		// Arrange of the control with 15px spacing on top and bottom
		this._marketingConsent._root.style.display ="block";
		this._marketingConsent._root.style.clear ="both";
		this._marketingConsent._root.style.paddingTop = "15px";
		this._marketingConsent._root.style.paddingBottom = "15px";
	},
	
    /**
     * function which will be called once the view is destroyed.
     * @function destroy
     */
    destroy: function() {
    	ovi.debug("Inside SSOAboutView destroy");
    	

    	this._mobileNumberField.destroy();
    	this._dobLabel.destroy();
    	this._dobField.destroy();
    	
        this._super.apply(this, arguments);
    },
    
	//@TODO: CR: MEDIUM: Private method. Use Prefix "_"
    /**
     * @private:
     * Function which will be triggered on why link is clicked.
     * @function handleWhyLink
     */
    handleWhyLink: function() {   
	//@TODO: CR: CRITICAL: Avoid hardcoding of URL. Move them to 
	//         some configuration file 	
	//@TODO: CR: MEDIUM: Move away from using 'baseurl' with hardcoding
	//     0/1/2 with enumeration
        var appmanagementObj= this.applicationController.getAppMgmtObj();
        if (this.applicationController.settings.get('baseurl') == 0) {
            var whyUrl_testing= "https://nabbi.noklab.com/acct/public/safetyTips?lang="+this.applicationController.getPhoneLang();
            appmanagementObj.launch({appid: "0x10008D39"}, ovi.service.ApplicationManagement.prototype.runtime.NATIVEPLATFORM, {docname:  whyUrl_testing});
        } else {            
            var whyUrl_ovi= "https://www.ovi.com/acct/public/safetyTips?lang="+this.applicationController.getPhoneLang();
            appmanagementObj.launch({appid: "0x10008D39"}, ovi.service.ApplicationManagement.prototype.runtime.NATIVEPLATFORM, {docname:  whyUrl_ovi});
        }
    },
    
	//@TODO: CR: MEDIUM: Function description block missing
    /**
     * 
     * @function
     */
    onViewSubmit : function() {
		// clear any previous error message
		//this._mobileNumberField.setMessage("");
        //this._emailField.setMessage("");		
		// validate the inputs 
		//@TODO: CR: MEDIUM: Use hungarian notation for variables name.
        //var result_mobileNumber  = ssoui.utils.SSOUtil.validateMobileNumber(this._mobileNumberField.getProperty('value'));           
        //var result_emailid       = ssoui.utils.SSOUtil.validateEmailId(this._emailField.getProperty('value'));
		
        //@TODO: CR: MEDIUM: Can directly call this._dobField.getDay() in below method
        //    instead of creating local variable [as they are not used further]
		//@TODO: CR: MEDIUM: Same for countryName, dateOfBirth
		
		//Get the country selected from the drop down
       // var countryName = this._countrylistdropdown.getProperty('item');
        
        var dateOfBirth = this._dobField.getValue();
		//@TODO: CR: MEDIUM: Can directly call this._dobField.getDay() in below method
		//    instead of creating local variable [as they are not used further]
        var day = this._dobField.getDay();
        var month = this._dobField.getMonth();
        var year = this._dobField.getYear();
        
        var result_dateOfBirth = ssoui.utils.SSOUtil.validateDateOfBirth(day,month,year);
        if(!result_dateOfBirth) {
        	SSOUIHelper.showError(sso_msg_0034);	
        	return false;
        };
        this.model.setMobilenumber(this._mobileNumberField.getProperty("mobileNumber"));       
        this.model.setCountry(this._mobileNumberField.getProperty("countryCode"));
        this.model.setDOB(dateOfBirth);   
		return true;
    },
    
	//@TODO: CR: MEDIUM: Below code comment is misleading. 
	// It is set the data to preserve the data for "back" & "next" screen nav
    /**
     * This function will be triggered when user press next button.
     * In this function the user entered values will be updated to the model 
     * @function onViewCancel
     */
    onViewCancel : function() {
    	this.model.setMobilenumber(this._mobileNumberField.getProperty("mobileNumber"));
		this.model.setCountry(this._mobileNumberField.getProperty("countryCode"));        
        this.model.setDOB(this._dobField.getValue());
		//@TODO: CR: MEDIUM: Why is return true required?  
		return true;
    }    
});