/**
 *
 * Description : A class that extends ssoui.views.SSOWizardView
 *               A page which displays the account created confirmation details.
 * <p>
 * Filename    : SSOAccCreatedView.js
 * <p>
 * Part of     : View
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @class SSOAccCreatedView
 * @name  SSOAccCreatedView 
 */

ovi.provide('ssoui.views.SSOAccCreatedView');
// system includes
ovi.require('ovi.sisu.HTMLView');
ovi.require('ovi.ui.Button');
ovi.require('ovi.ui.Label');
ovi.require('ovi.ui.TextInput');

// local includes
ovi.require('ssoui.views.SSOWizardView');
ovi.require('ssoui.ui.SSOTextInput');
ovi.require('ssoui.ui.TextLink');
ovi.require('ssoui.ui.SSOPasswordInput'); 
ovi.require('ssoui.utils.SSOUtil',false);
ovi.declare('ssoui.views.SSOAccCreatedView', {
    
    Extends: ssoui.views.SSOWizardView,
    
    initialize: function() {
		var _title = sso_signup_header_noacreated;
		var _isParentApproved = this.settings.get('isParentApproved');
		if(_isParentApproved) {			
			_title = sso_signup_header_childacccreated;
		}
				
		this._super(_title, "", 
		{
			text: sso_button_sk_continue,
			type: "affirmative"
		},
		{ 
		    text: ""
        });
    },
    
    //@TODO: CR: MEDIUM: Missing documentation block for function
    render: function() {
    	this._super();   	

        var _isParentConsent = this.settings.get('isParentalConsent');
        var _isParentApproved = this.settings.get('isParentApproved');
        
        if(_isParentApproved) {			
			this.setTitleText(sso_signup_header_childacccreated);
		} else {
			this.setTitleText(sso_signup_header_noacreated);
		}        
        
        if(_isParentConsent == true && (_isParentApproved === undefined || _isParentApproved == false) ) {
        	var _model = this.getModel("SSOParentSignUp");
        	var _createdHeader = ssoui.utils.SSOUtil.replaceString(sso_signup_header_parentacccreated01, _model.getEmailid());
        	this.setHeaderText(_createdHeader);
        	
        	this._success2Label = new ovi.ui.Label({ text: sso_signup_header_parentacccreated02, 
				 extraClass: "sso_subheader_Label" },  this.viewContainer);
        	
        	this._success3Label = new ovi.ui.Label({ text: sso_signup_header_parentacccreated03, 
				 extraClass: "sso_subheader_Label" },  this.viewContainer);
        } else {        	
    		var _model = this.getModel("SSOSignUp");
    		var _createdHeader = ssoui.utils.SSOUtil.replaceString(sso_signup_label_noacreationsuccess1, _model.getEmailid());
    		this.setHeaderText(_createdHeader);
    		
        	this._success2Label = new ovi.ui.Label({ text: sso_signup_label_noacreationsuccess2, 
        											 extraClass: "sso_subheader_Label" },  this.viewContainer);
        }
    },
    
    /**
     * function which will be called once the view is destroyed.
     * @function destroy
     */
    destroy: function() {
    	ovi.debug("Inside SSOAccCreatedView destroy");    	
    	 
		this._success2Label.destroy();
		if(this._success3Label) {
			this._success3Label.destroy();
		}
		
        this._super.apply(this, arguments);
    },
    
    //@TODO: CR: MEDIUM: Missing documentation block for function
    onViewSubmit: function() {
    	//ovi.publish("finishWizard");
    	return true;
    }
});