/**
 *
 * Description : A class that extends ssoui.views.SSOBaseView
 *               
 * <p>
 * Filename    : SSOAccIdentifiedView.js
 * <p>
 * Part of     : View
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @class SSOAccIdentifiedView
 * @name  SSOAccIdentifiedView 
 */

//@TODO: CR: MEDIUM: File description block needs more elaboration on the
//      functionality of the file/class.
ovi.provide('ssoui.views.SSOAccIdentifiedView');
// system includes
ovi.require('ovi.ui.Label');
ovi.require( 'ovi.ui.CheckBox');
// local includes

ovi.require('ssoui.views.SSOBaseView');
ovi.require('ssoui.ui.SSOTextInputNew');
ovi.require('ssoui.ui.TextLink');
ovi.require('ssoui.ui.SSOPasswordInputNew'); 
ovi.require('ssoui.utils.SSOUtil',false);
ovi.require('ssoui.ui.SSOUIHelper');
ovi.declare('ssoui.views.SSOAccIdentifiedView', {
    
	//@TODO: CR: MEDIUM: Description block missing
    Extends: ssoui.views.SSOBaseView,
    
    //@TODO: CR: MEDIUM: Description block missing
    /**
     * 
     * @function
     */
    initialize: function() {
		this._username = "";
    	var _preAccount = this.getModel("SSOSignUp").getPreAccount();
		//@TODO: CR: CRITICAL. Check for _preAccount not being null
		//   along with .username. Use !== instead of !=
    	if(typeof _preAccount != "undefined") {
    		this._username = _preAccount.username;
    	}
		var _viewTitle = ssoui.utils.SSOUtil.replaceString(sso_signin_header_welcomeback, this._username);
        this._super(sso_signin_title_welcomeback, _viewTitle, 
		{
			text: sso_button_sk_signin,
			type: "affirmative"
		},
		{
			text: sso_button_sk_cancel 
		} );
    },
    
    //@TODO: CR: MEDIUM: Description block missing
    render: function() {
         
    	ovi.debug('inside ssosignup render');
		var self = this;
    	this._super();
    	
        this._subTitleTextLabel = new ovi.ui.Label({ text: sso_signin_header_plssignin }, this.elementContainer, "first");
		//@TODO: CR: MEDIUM Move below property to CSS
		this._subTitleTextLabel._root.style.display = "block";
		this._subTitleTextLabel._root.style.paddingTop = "15px";
		this._subTitleTextLabel._root.style.paddingBottom = "15px";
		 this._subTitleTextLabel._root.className = "sso_header_Label";
        
        this._passwordTextField = new ssoui.ui.SSOPasswordInputNew(
		                                          { HdrLabel: sso_signin_label_password, maxLength:"18", 
                                                    TextValue:""}, 
                                                    this.element1);
		
		// Create Forgot password link											
        this.createForgotPasswordLink(self);
		
		// Create I am Not user link
		this.createIamNotTheUserLink(self);													
    },
	
	/**
	* Checks whether the sent username is valid or not 
	* @function createForgotPasswordLink
	* @param {object} aSelf The userName to be validated.
	*/
	createForgotPasswordLink: function(aSelf) {
		
		// Forgot password Link (ItemPane within List)          
        aSelf._forgotPassword = new ovi.ui.List({}, aSelf.element3);
        aSelf._forgotPassword.add(new ovi.ui.ItemPane(
        {
            title: sso_button_forgotpassword,
            addition:">"
        }));            
            
        // Add the selected event for the forgot password button
        // SSO Password recovery controller is activated 
        // when the forgot password button is clicked   
        aSelf._forgotPassword.addEventHandler("selected", function() {
            //self.cacheViewData();
            aSelf.applicationController.activate("SSOForgotPasswordWizard");  
        }, aSelf);
	},
	
	/**
    * Checks whether the sent username is valid or not 
    * @function createIamNotTheUserLink
    * @param {object} aSelf The userName to be validated.
    */
	createIamNotTheUserLink: function(aSelf) {
		var _imanotLabel = ssoui.utils.SSOUtil.replaceString(sso_signup_textlink_wrongusername, aSelf._username);
        
        // Forgot password Link (ItemPane within List)           
        aSelf.iamnotuserLink = new ovi.ui.List({}, aSelf.element4);
        aSelf.iamnotuserLink.add(new ovi.ui.ItemPane(
        {
            title: _imanotLabel,
            addition:">"
        }));            
            
        // Add the selected event for the forgot password button
        // SSO Password recovery controller is activated 
        // when the forgot password button is clicked   
        aSelf.iamnotuserLink.addEventHandler("selected", function() {
            //self.cacheViewData();
            aSelf.settings.set("predetectedusername", aSelf._username);
            aSelf.applicationController.activate("SSOSignUp"); 
        }, aSelf);
	},
	
    /**
     * function which will be called once the view is destroyed.
     * @function destroy
     */
    destroy: function() {
    	ovi.debug("Inside SSOAccIdentifiedView destroy");
    	
    	//this._userNameTextField.destroy();
    	this._subTitleTextLabel.destroy();
    	this._passwordTextField.destroy();

        this._super.apply(this, arguments);
    },
    
    //@TODO: CR: MEDIUM: Function description block missing
    onRSKClick: function() {
        var eventMessageObj= this.applicationController.getEventMessageObj();
        eventMessageObj.post(this.applicationController.settings.get('ssoUIContext'),ssoui.utils.SSOUtil.convertToJSONFormat(SSOConstant.Error,SSOConstant.Cancelled));
        window.close(); 
    },
    
    //@TODO: CR: MEDIUM: Function description block missing
	//@TODO: CR: MEDIUM: Why do we have return true/false?
    onLSKClick: function() {

		this._passwordTextField.clearErrorLabel();
        
        //Create the error message object for the password
      
        var errMsgPassword = new Object();
        errMsgPassword.Message = "";

		var password = 	this._passwordTextField.getInputText();
		
			//Validate the password entered by the user  
        var _isValidPassword = ssoui.utils.SSOUtil.validatePassword(password,
                  errMsgPassword);
        
        // If both username and password entrered are valid. then publish the signin event
        // Else display error & stay in the same screen
        if (_isValidPassword == true) {    
			// Store the value in the Model, on publish of success,
			// Model can read this value for authentication       
			this.model = this.getModel("SSOSignIn");
		
            // Always use setRmbrMe as true
            // Publish success of local validation & perform signIn (SSOSignUpController)
			this.model.setRmbrMe(true);
			this.model.setUsername(this._username);
            this.model.setPassword(password);
			
			ovi.publish("onSignInClick");
			return true;
        } 
		else {
            // Local validation failed. Display error
            if(_isValidPassword == false) {
                this._passwordTextField.setErrLabelText(errMsgPassword.Message);
            }
            return false;
        }
	}

});