/**
 *
 * Description : A class that extends ovi.sisu.HTMLView
 *               A page which contains a checkbox to
 *
 * <p>
 * Filename    : SSOAcctMngtSignOutView.js
 * <p>
 * Part of     : View
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @version %version:   7.1.6.1.2 %
 * @class SSOAcctMngtRememberMeView
 * @name  SSOAcctMngtRememberMeView 
 */

ovi.provide( 'ssoui.views.SSOAcctMngtSignOutView');
// system includes
ovi.require( 'ovi.ui.Label');
ovi.require( 'ovi.ui.TextInput');
ovi.require( 'ovi.ui.CheckBox');
//local includes
ovi.require( 'ssoui.ui.SSOPasswordInput'); 
ovi.require( 'ssoui.utils.SSOUtil', false);
ovi.require( 'ssoui.views.SSOBaseView');
ovi.declare( 'ssoui.views.SSOAcctMngtSignOutView'    ,{
    
    /**
     * SSOAcctMngtRememberMeView extends the SSOBaseView class.
     * @extends ovi.sisu.SSOBaseView
     */
    Extends: ssoui.views.SSOBaseView,
    
    /**
     * Calls the init of the base class     
     * @function initialize
     */
    initialize: function() {        
        this._super(sso_signin_title_sure, sso_acmgmt_header_signout, 
        {
            text: sso_button_sk_signout,
			type: "affirmative"
        },
        {
            text: sso_button_sk_back
        });		
		
        this._contextId = SSOConstant.AccMgtContext;
        //Get the model to update the data
        this.model = this.getModel('SSOSignIn');
    },
    
    /**
     * Creates two password field for current password and the new password
     * user can save the new password or cancel. 
     * User can activate the view
     * @function render
     */
    render: function() {    
        
        this._super();
        
    },
    
    /**
     * function which will be called once the view is destroyed.
     * @function destroy
     */
    destroy: function() {
    	ovi.debug("Inside SSOAcctMngtChangePasswordView destroy");
        this._super.apply(this, arguments);
    },
   
   
    /**
     * When the LSK - Save button is clicked.      
     * @function onLSKClick
     */    
    onLSKClick: function() {  
    	//@todo implement sign-out mechanism
    	this.applicationController.getController('SSOAcctMngtSignOut').moveback();
    },
    
    /**
     * When the RSK - Cancel button is clicked. 
     * Cancels the screen and moves to the account management screen
     * @function moveBack
     */   
     onRSKClick: function() {
        this.applicationController.getController('SSOAcctMngtSignOut').moveback();       
    }    
});