//@TODO: CR: MEDIUM: File description block missing
ovi.provide('ssoui.views.SSOBaseView');

// system includes
ovi.require('ovi.sisu.SnippetView');
ovi.require('ovi.ui.Label');
ovi.require( 'ovi.orientation' );
ovi.require( 'ovi.ui.Button');

// local includes
ovi.require( 'ssoui.ui.SSOSoftKey');
ovi.require( 'ssoui.ui.SSOProgressBar' );
ovi.require( 'ssoui.ui.SSOUIHelper');
ovi.require( 'ssoui.ui.SSOSpinner');
ovi.declare( 'ssoui.views.SSOBaseView' , {
    
    Extends: ovi.sisu.SnippetView,
	
	//@TODO: CR: Function description block is missing
    initialize: function(title, header, lsk, rsk) {        
        this._super();
        this._title = title;
        this._header = header;
		//@TODO: CR: MEDIUM: Rename _lsk / _rsk with _lskText / _rskText
        this._lsk = lsk;
        this._rsk = rsk;
		if ((this._lsk) && this._lsk.type === undefined)
		{
			this._lsk.type = "";
		}
        if ((this._rsk) && this._rsk.type === undefined)
        {
            this._rsk.type = "";
        }
		this._contextId = SSOConstant.SignUpContext;
        //add a default template.
        this.template = this.getTemplate("SSOUITemplate");  
        
    	this._errTitle = sso_msg_network_sorry;
        this._errHeader = sso_msg_network_unable;
        this._errLsk = {
    			text: sso_button_sk_back,
    			type: "affirmative"
    		  };        
		
    },
	
	/**
     * Function to return curren UI Layout
     * @function currentOrientation
     * @return {enum} SSOOrientation.Landscape / SSOOrientation.Potrait
     */
    currentOrientation: function() {
        if (ovi.orientation.NAME_LANDSCAPE == ovi.orientation.getCurrentName())
        {
            return SSOOrientation.Landscape;
        }
        return SSOOrientation.Portrait;
    },
    
    /**
     * 
     * @function render
     */
    render: function() {
    	var self = this;
    	// Call parent render
    	this._super.apply(this, arguments);
        
    	ovi.debug("Inside base view render");
    	
    	try {
	        
    		//SSOUIHelper.hideProgressView();
			
			this._titleTextLabel = new ovi.ui.Label({ text: this._title}, this.viewTitle);
            this._titleTextLabel._root.className="sso_Title_Label";

	        this._headingTextLabel = new ovi.ui.Label({ text: this._header}, this.viewHeader);
	        this._headingTextLabel._root.className="sso_header_Label";
	        
	        this._progressBar = new ssoui.ui.SSOProgressBar({}, this.viewContainer);
	        
	        this._progressSpinner = new ssoui.ui.SSOSpinner({hidden: true}, this.viewContainer);
	        
	        // add the left soft key button
            this._lskbutton = new ovi.ui.Button({ text: this._lsk.text, type: this._lsk.type}, this.lskContainer);
	        this._lskbutton.addEventHandler("selected", function() {
	        	//this function will be implemented by the extending views.
	        	if(this.onLSKClick) {
	        		this.onLSKClick();
	        	} else {
					ovi.debug("onLSKClick is not defined in the view");
				}
	        }, this);
	        
	        if(this._lsk == "" || this._lsk.text == "" || this._lsk.text == " ") {
	        	this.disableLSK();
	        }	        
	        
	       if(this._rsk == "" || (this._rsk.text !== undefined && this._rsk.text == "")) {
			  ovi.debug("RSK is undefined. Make the display as none");		
			  this.rskContainer.style.display = "none";
		   } else {
				// add the right soft key button
				this._rskbutton = new ovi.ui.Button({ text: this._rsk.text, type: this._rsk.type}, this.rskContainer);
				this._rskbutton.addEventHandler("selected", function() {
					//this function will be implemented by the extending views.
					if(this.onRSKClick) {
						this.onRSKClick();
					} else {
						ovi.debug("onRSKClick is not defined in the view");
					}
		        }, this);
		   }
	       
	       // Error View 
			this._errTitleTextLabel = new ovi.ui.Label({ text: this._errTitle}, this.errTitle);
            this._errTitleTextLabel._root.className="sso_Title_Label";

	        this._errHeadingTextLabel = new ovi.ui.Label({ text: this._errHeader}, this.errHeader);
	        this._errHeadingTextLabel._root.className="sso_header_Label";
	        
	        this._errSubTitleTextLabel = new ovi.ui.Label({ text: sso_msg_sorry_trylater },
	        		this.errContainer); 
	        this._errSubTitleTextLabel._root.className="sso_header_Label";		
	        
	        // add the left soft key button
            this._errLskbutton = new ovi.ui.Button({ text: this._errLsk.text, type: this._errLsk.type}, this.errlskContainer);
	        this._errLskbutton.addEventHandler("selected", function() {
	        	//this function will be implemented by the extending views.
					ovi.debug("TODO: Return to the previous view");
					self._hideErrorView();	  
	        }, this);
	        
	        this._hideErrorView();
		   
		   SSOUIHelper.init();
		   
    	} catch(ex) {
    		//@todo rplace with popup dialog
    		ovi.error("Error in loading baseView: "+ ex.message);
    	}
    	
    	ovi.debug("Base view rendering done");
    },
    
    /**
     * Function to hide current display view & show the network error view
     * @private
     * @function showErrorView
     * @returns void
     */
    showErrorView: function() {
		var _errorPage = ovi.dom.byId("error_page");
		var _viewPage = ovi.dom.byId("page");
		
		if (_errorPage)
		{
			_errorPage.style.display = "block";
			_viewPage.style.display = "none";
		}
		else
		{
			ovi.error("Error Page not available");
		}     	
    },
    
    /**
     * Function to display network error page.
     * @private
     * @function _hideErrorView
     * @returns void
     */
    _hideErrorView: function(){
		var _errorPage = ovi.dom.byId("error_page");
		var _viewPage = ovi.dom.byId("page");
		
		if (_errorPage)
		{
			_errorPage.style.display = "none";
			_viewPage.style.display = "block";
		}
		else
		{
			ovi.error("Error Page not available");
		}    	
    },
    

    
    /**
     * function which will be called once the view is destroyed.
     * @function destroy
     */
    destroy: function() {

		this._titleTextLabel.destroy();
    	this._headingTextLabel.destroy();
    	
    	this._progressBar.destroy();
    	
    	if(this._lskbutton) {    		
    		this._lskbutton.destroy();
    	}
    	
    	if(this._rskbutton) {    		
    		this._rskbutton.destroy();
    	}
    	
        this._super.apply(this, arguments);
    },
        
    /**
     * Function to show the progress indicator.
     * @function
     */
    showProgress: function(aIsModal) {
    	this._progressBar.start();
    	if(aIsModal !== undefined && aIsModal == true) {
    		this._progressBar.setProperty("isModal", true);
    	}
    },
    
    /**
     * Function to hide the progress indicator.
     * @function
     */
    hideProgress: function() {
    	this._progressBar.stop();
    },
    
    showSpinner: function() {
    	this._progressSpinner.setProperty('hidden', false);
    },
    
    hideSpinner: function() {
    	this._progressSpinner.setProperty('hidden', true);
    },
    
    /**
     * Launch the context sensitive help.
     * @funciton launchContextSensitiveHelp
     * @param {string object} aContextid the context id of the help
     * content to be launched. Its nothing but the help topic relevant to
     * the launched context                 
     */              
    launchContextSensitiveHelp: function() {
      var model = this.getModel('SSOHelp');
	  //@TODO: CR: HIGH: ContextSenstive Help is not supported by CP Platform.
	  //   We do launch user guide page. Hence, we should remove
	  //   usage of _contextId from all places. 
      var _Contextid = this._contextId;
      model.launchContextSensitiveHelp(_Contextid); 
    },
    
     /**
     *  Function to disable LSK button.
     * @function disableLSK
     */
    disableLSK: function() {
    	this._lskbutton.setProperty("disabled", true);
    },
    
    /**
     * Function enable the LSK button
     * @function enableLSK
     */
    enableLSK: function() {
    	this._lskbutton.setProperty("disabled", false);
    },
    
    /**
     * Function to disable RSK button
     * @function disableRSK
     */
    disableRSK: function() {
    	this._rskbutton.setProperty("disabled", true);
    },
    
    /**
     * Function to enable RSK button
     * @function enableRSK
     */
    enableRSK: function() {
    	this._rskbutton.setProperty("disabled", false);
    },
	
	/**
	 * Function to set the header Text Label
	 * @function setHeaderText
	 * @param newHeaderText New text to be set in the header
	 */
	setHeaderText: function(newHeaderText) {
        this._headingTextLabel.setProperty('text', newHeaderText);
	},
    
	/**
	 * Function to set the title text label
	 * @param {String} aTitleText - title text
	 * @function setTitleText
	 */
    setTitleText: function(aTitleText) {
		this._titleTextLabel.setProperty('text', aTitleText);
	}
});