/**
 *
 * Description : A class that extends ssoui.views.SSOWizardView
 *               A page which displays the account created confirmation details.
 * <p>
 * Filename    : SSOAccCreatedView.js
 * <p>
 * Part of     : View
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @class SSOAccCreatedView
 * @name  SSOAccCreatedView 
 */

ovi.provide('ssoui.views.SSOParentInfoView');
// system includes
ovi.require('ovi.sisu.HTMLView');
ovi.require('ovi.ui.Button');
ovi.require('ovi.ui.Label');
ovi.require('ovi.ui.TextInput');

// local includes
ovi.require('ssoui.views.SSOBaseView');
ovi.require('ssoui.ui.SSOTextInput');
ovi.require('ssoui.ui.TextLink');
ovi.require('ssoui.ui.SSOPasswordInput'); 
ovi.require('ssoui.utils.SSOUtil',false);
ovi.declare('ssoui.views.SSOParentInfoView', {
    
    Extends: ssoui.views.SSOBaseView,
    
    /**
     * Initialization of view
     * @function initialize
     */
    initialize: function() {					
		this._super(sso_signup_label_helloparent1, "", 
		{
			text: sso_button_sk_continue,
			type: "affirmative"
		},
		{ 
		    text: sso_button_sk_nothanks
        });	
    },
    
    //@TODO: CR: MEDIUM: Missing documentation block for function
    render: function() {
		this._super();
		this._parentConsentLabel = new ovi.ui.Label({ text: sso_signup_label_helloparent2 },  this.viewContainer);	
		this._parentConsent2Label = new ovi.ui.Label({ text: sso_signup_textlink_helloparent2 },  this.viewContainer);
		this._parentConsent3Label = new ovi.ui.Label({ text: sso_signup_label_helloparent3 },  this.viewContainer);
		
		this._parentConsent4Label = new ovi.ui.Label({ text: sso_signup_label_helloparent4 },  this.viewContainer);
		this._parentConsent4Label._root.style.display = "block";
		this._parentConsent4Label._root.style.paddingTop = "20px";//@todo use css class
		
		this._parentConsent5Label = new ovi.ui.Label({ text: sso_signup_label_helloparent5 },  this.viewContainer);
		this._parentConsent5Label._root.style.display = "block";
		this._parentConsent5Label._root.style.paddingTop = "20px";//@todo use css class
		
		new ovi.ui.ItemPane(
		        {
		            title: sso_signup_textlink_onlinesafety,
		            addition:">"
		        }, this.viewContainer);    	
    },
    
    /**
     * function which will be called once the view is destroyed.
     * @function destroy
     */
    destroy: function() {
    	ovi.debug("Inside SSOAccCreatedView destroy");
    	
    	this._parentConsentLabel.destroy();
        this._parentConsent2Label.destroy();
            	
        this._super.apply(this, arguments);
    },

    onLSKClick: function() {
    	this.settings.set("isParentSignUp", true);
    	
    	/*var _keys = this.settings.get();
    	alert(JSON.stringify(_keys));
    	for(var i=0;i<_keys.length;i++) {
    		alert(_keys[i].key);
    	}*/
    	
    	this.applicationController.activate("SSOSignUp");    	
    },
    
    onRSKClick: function() {
    	this.settings.set("isParentDenied", true);
    	this.applicationController.activate("SSOAccFailed");
    }
});