/**
 *
 * Description : A class that extends ovi.sisu.Model
 *               Maintains the wizard for the signin usecase 
 * <p>
 * Filename    : SSOForgotPasswordView.js
 * <p>
 * Part of     : View
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @version %version:   16.1.1 %
 * @class SSOPRVerificationView
 * @name SSOPRVerificationView 
 */

//@TODO: CR: MEDIUM: File header description block is not talking about PR
ovi.provide('ssoui.views.SSOPasswordSuccessView');
// system includes
ovi.require('ovi.sisu.HTMLView');
ovi.require('ovi.ui.Button');
ovi.require('ovi.ui.Label');
ovi.require('ovi.ui.Image');

// local includes
ovi.require('ssoui.ui.SSOTextInputNew');
ovi.require('ssoui.ui.SSOMobileInput');
ovi.require('ssoui.ui.TextLink');
ovi.require('ssoui.utils.SSOUtil', false);
ovi.require('ssoui.views.SSOWizardView');
ovi.require('ssoui.ui.SSOImageLink');
ovi.declare('ssoui.views.SSOPasswordSuccessView'    ,{

	//@TODO: CR: MEDIUM: Documentation missing for extends    
	Extends: ssoui.views.SSOWizardView,

  /**
   * Consructor
   * @function  initialize
   */
  initialize: function() {
    this._super(sso_pwdrecovery_header_resetrequest, sso_pwdrecovery_label_checkemailsms1, {
        text: sso_button_sk_continue,
        type: "affirmative"
    },{ 
	    text: ""
    });
  },
  
  /**
   * Overriden render function
   * @function  render
   */
  render: function() {
	  this._super.apply(this, arguments);    
  },
  
  /**
   * function which will be called once the view is destroyed.
   * @function destroy
   */
  destroy: function() {
  	ovi.debug("Inside SSOPRVerificationView destroy");  	
  	this._super.apply(this, arguments);
  },
  
  /**
   * This funciton validates the mobile or email field, and then publishes if everything is valid
   * @function  render
   */
  onViewSubmit: function() {
	  return true;
  }
  
});