/**
 *
 * Description : A class that extends ssoui.views.SSOWizardView
 *               A page which displays the account created confirmation details.
 * <p>
 * Filename    : SSOAccCreatedView.js
 * <p>
 * Part of     : View
 * <p>
 * ============================================================================
 * <p>
 * Copyright (C) 2008 Nokia.  All rights reserved.
 * <p>
 * This material, including documentation and any related computer
 * programs, is protected by copyright controlled by Nokia.  All
 * rights are reserved.  Copying, including reproducing, storing,
 * adapting or translating, any or all of this material requires the
 * prior written consent of Nokia.  This material also contains
 * confidential information which may not be disclosed to others
 * without the prior written consent of Nokia.
 * <p>
 * ============================================================================
 * @class SSOAccCreatedView
 * @name  SSOAccCreatedView 
 */

ovi.provide('ssoui.views.SSOPermissionView');
// system includes
ovi.require('ovi.sisu.HTMLView');
ovi.require('ovi.ui.Button');
ovi.require('ovi.ui.Label');
ovi.require('ovi.ui.TextInput');

// local includes
ovi.require('ssoui.views.SSOBaseView');
ovi.require('ssoui.ui.SSOTextInput');
ovi.require('ssoui.ui.TextLink');
ovi.require('ssoui.ui.SSOPasswordInput'); 
ovi.require('ssoui.utils.SSOUtil',false);
ovi.declare('ssoui.views.SSOPermissionView', {
    
    Extends: ssoui.views.SSOBaseView,
    
    /**
     * Initialization of view
     * @function initialize
     */
    initialize: function() {					
		this._super(sso_signup_label_parentconsent1, "", 
		{
			text: sso_button_sk_continue,
			type: "affirmative"
		},
		{ 
		    text: ""
        });	
    },
    
    //@TODO: CR: MEDIUM: Missing documentation block for function
    render: function() {
		this._super();
		this._parentConsentLabel = new ovi.ui.Label({ text: sso_signup_label_parentalconsent },  this.viewContainer);	
		
		new ovi.ui.ItemPane(
		        {
		            title: sso_signup_textlink_helloparent3,
		            addition:">"
		        }, this.viewContainer);
		
		this._parentConsent2Label = new ovi.ui.Label({ text: sso_signup_label_parentconsent2 },  this.viewContainer);
    	
    	
    },
    
    /**
     * function which will be called once the view is destroyed.
     * @function destroy
     */
    destroy: function() {
    	ovi.debug("Inside SSOAccCreatedView destroy");
    	
    	this._parentConsentLabel.destroy();
        this._parentConsent2Label.destroy();
            	
        this._super.apply(this, arguments);
    },

    onLSKClick: function() {
    	this.applicationController.activate("SSOParentInfo");	
    }
});