ovi.provide("orpheus.models.AccountModel");ovi.require("ovi.service.sso.SSO",false);ovi.require("orpheus.models.BaseMusicModel");ovi.require("orpheus.models.SettingsModel");ovi.require("ovi.Logger");ovi.declare("orpheus.models.AccountModel",{Extends:orpheus.models.BaseMusicModel,initialize:function(){this._super();this.settingsModel=this.applicationController.settingsModel;this.noa();this._getSysInfoSettings();this.set("LoginCompleted",false);ovi.publish("moduleReady",["account"])},_deviceStateKeys:["SSOAuthed","IMEI","PID","territory","userId","mobileCountryCode","upgradePrompt","alcCreditBalance","isRegisteredDevice","CWMExpiry","preAccountExpiry","moreInfoRequired","CWMPreAccountMissing"],getUserState:function(){if(this.get("CWMPreAccountMissing")===true){return"preAccountFailed"}else{if(this.get("preAccountExpiry") instanceof Date){return"preAccount"}else{if(this.get("CWMExpiry") instanceof Date&&this.get("isRegisteredDevice")===true){return"CWM"}else{return"ALC"}}}},_getSysInfoSettings:function(){var d,f=null,b=null,c=null,a=true,h;if(typeof nokia!=="undefined"&&nokia.hasOwnProperty("device")&&nokia.device.hasOwnProperty("load")){d=nokia.device.load("sysinfo");if(typeof(d)==="object"&&d.hasOwnProperty("getChannel")){try{this.set("IMEI",d.getChannel("IMEI").imei);this.set("PID",d.getChannel("PublicId").publicId);this.set("OS",d.getChannel("PlatformName").platformName);h=d.getChannel("Network");if(h.hasOwnProperty("mobileCountryCode")){this.set("MCC",h.mobileCountryCode);ovi.Logger.debug("MCC detected: "+h.mobileCountryCode)}a=false}catch(g){ovi.Logger.error("Unable to load sysinfo, error: ",g)}}}},details:{},set:function(a,b){if(typeof(a)==="string"&&b!==undefined){this.details[a]=(typeof(b)==="number"||typeof(b)==="boolean"||b instanceof Date||typeof(b)==="object")?b:""+b;ovi.Logger.debug("accountModel.set() received key: "+a+" and value: "+b);if(a==="territory"){this.settingsModel.setSetting("territory",b);this.applicationController.notifyParentApp("ORPHEUS_TERRITORY_CHANGED",b)}else{if(a==="storeConfig"){b.cacheTime=this.getRealTime();this.settingsModel.setSetting("storeConfig",b)}}if(a in this.details){return true}}return false},get:function(b){var f,d,e,c,a;if(typeof(b)==="string"){ovi.Logger.debug("accountModel.get() attempting to retrieve key: "+b);switch(b){case"storeConfig":f=this.settingsModel.getSetting("storeConfig");if(f!==null&&f.hasOwnProperty("cacheTime")){ovi.Logger.debug("retrieved config from accountModel with cacheTime: "+f.cacheTime)}ovi.Logger.debug('accountModel.get("storeConfig") got: '+f);return typeof(f)==="undefined"?null:f;case"territory":d=this.settingsModel.getSetting("territory");return typeof(d)==="undefined"?null:d;case"deviceLanguage":e=navigator.language;return typeof(e)==="undefined"?null:e;case"consumerKey":case"consumerSecret":case"BasicAuthHeader":c=this.settingsModel.getConfig("oAuth");return(b in c)?c[b]:null;case"SSOEnvironment":case"serviceId":a=this.settingsModel.getConfig("SSOUIModel");return(b in a)?a[b]:null;default:return(b in this.details)?this.details[b]:null}}return null},getDeviceStateSummary:function(){var b,c=[],a=this._deviceStateKeys;for(b=0;b<a.length;b+=1){c.push(a[b]+": "+this.get(a[b]))}return c.join("\n")},resetDeviceStates:function(){var a;for(a=0;a<this._deviceStateKeys.length;a+=1){if(this._deviceStateKeys[a]!=="territory"&&this._deviceStateKeys[a]!=="IMEI"&&this._deviceStateKeys[a]!=="PID"&&this._deviceStateKeys[a]!=="SSOActive"){delete (this.details[this._deviceStateKeys[a]])}}},_receiveGSDSuccess:function(c,b){var a=null;b=typeof b==="function"?b:false;if(!!c){if(b!==false){if(typeof c==="undefined"||""+c==="null"){ovi.Logger.warn("invalid Global Service Document received from PAPI");return false}a=JSON.parse(c);a=this.removeCwmOnlyStoresFromGSD(a);ovi.Logger.debug("received GSD");this.set("GSD",a);b(a)}else{ovi.Logger.warn("no fireNext defined in AccountModel._receiveGSDSuccess() so returning GSD object");a=JSON.parse(c);a=this.removeCwmOnlyStoresFromGSD(a);this.set("GSD",a);return a}return true}return false},_receiveGSDFail:function(a){ovi.Logger.error("_receiveGSDFail error. data: "+a);return false},removeCwmOnlyStoresFromGSD:function(a){var n,m,f,e,b=a.workspace,d=b.length,o=[],h,c=[],p,g;if(a.workspace.length>1){a.workspace=[];for(n=0,m=0,f=0,e=0;n<d;n+=1){if(!("settings" in b[n])||"settings" in b[n]&&b[n].settings.alcEnabled+""!=="false"){a.workspace[m]=b[n];if("redirectCode" in a.workspace[m]){c[e]=m;e+=1}m+=1}else{o[f]=b[n];f+=1;ovi.Logger.warn("AccountModel filtering CWM ONLY territory: "+b[n].countryCode.toUpperCase())}}h=o.length;p=c.length;for(n=0,g=0;n<p;n+=1){for(m=0;m<h;m+=1){if(a.workspace[c[n]-g].redirectCode===o[m].countryCode){ovi.Logger.warn("AccountModel filtering "+a.workspace[c[n]].countryCode.toUpperCase()+" which maps to CWM ONLY territory: "+o[m].countryCode.toUpperCase());a.workspace.splice(c[n]-g,1);g+=1}}}}return a},uniqueCountryCodeFromGSD:function(a){},retrieveGlobalServiceDocument:function(m,c,i){var p=false,b=this.settingsModel.getBasePapiUri(),f={format:"json",territory:this.get("territory"),testStores:false,useip:true,mcc:this.get("MCC"),token:this.settingsModel.getDeviceToken(),storeConfig:true},o,l={},e,d,k,a,n,j,g=this;i=typeof i==="function"?i:false;if(typeof m==="undefined"||m===null){m={};ovi.Logger.warn("retrieveGlobalServiceDocument received no gsdOptions object, defaulting all values!")}b=("gsdBaseURI" in m)?m.gsdBaseURI:b;c=typeof c!=="undefined"?c:true;if(c&&!i){ovi.Logger.warn("retrieveGlobalServiceDocument in async mode but no fireNext function provided!")}f.format=f.format;f.territory=("territory" in m)?m.territory:f.territory;f.testStores=(m.testStores===true)?true:f.testStores;f.token=("token" in m)?m.token:f.token;f.storeConfig=("storeConfig" in m)?m.storeConfig:f.storeConfig;if(m.usemcc===false){f.mcc=null}if(typeof(m.useip)==="boolean"){f.useip=m.useip}if("master" in m&&""+m.master==="true"){f.territory=null}n=new ovi.sisu.Settings();j=n.get("spoofIP");if(j!==undefined&&j!==null&&j!==""){m.spoofip=j;ovi.Logger.debug("Spoofed IP Asserted: "+j)}if(typeof m.spoofip==="string"){l["X-Forwarded-For"]=m.spoofip}d=this._buildGSDURI(b,f);o=new XMLHttpRequest();o.open("GET",d,c);for(e in l){if(l.hasOwnProperty(e)&&l[e]!==null){o.setRequestHeader(""+e,""+l[e]);ovi.Logger.debug("retrieveGlobalServiceDocument set Request Header: "+e+": "+l[e])}}this._attachTimeoutToXHR(o,"Timed out inside AccountModel.retrieveGlobalServiceDocument()");if(c){ovi.Logger.debug("making async GSD request");o.onreadystatechange=function(){if(o.readyState===4){var h=null;o.killRequestTimer();try{h=o.status}catch(q){ovi.Logger.error("error in get http status "+q);g._receiveGSDFail(h)}if((h+"")===(200+"")||(h+"")===(404+"")){g._receiveGSDSuccess(o.responseText,i)}else{if((h+"")===(500+"")||(h+""===(401+""))){g.applicationController.handleStartupRequestError(500)}else{g._receiveGSDFail(h)}}o=null}}}o.send(null);if(!c){o.killRequestTimer();if((o.status+"")===(200+"")||(o.status+"")===(404+"")){return this._receiveGSDSuccess(o.responseText)}else{g.applicationController.handleStartupRequestError(500);return this._receiveGSDFail(o.status)}}return true},getUniqueCountryFromGSD:function(d){var c,a,b;if(d.hasOwnProperty("workspace")&&typeof d.workspace.length!=="undefined"){c=d.workspace.length;if(c===1&&typeof(d.workspace[0])!=="undefined"){if(d.workspace[0].redirectCode){this.applicationController.settingsModel.setSetting("RedirectedTerritory",d.workspace[0].countryCode);b={territory:d.workspace[0].redirectCode,testStores:false,usemcc:false,useip:false,storeConfig:true};d=this.retrieveGlobalServiceDocument(b,false)}if(d.workspace[0].settings&&(d.workspace[0].settings.alcEnabled+"")!=="false"){ovi.Logger.error("getUniqueCountryFromGSD found 1 (alcEnabled) store");a=d.workspace[0].countryCode;if(typeof a!=="undefined"){ovi.Logger.debug("getUniqueCountryFromGSD returning countryCode: "+a);return a}}}}else{ovi.Logger.error("getUniqueCountryFromGSD reports unknown globalServiceDocumentObj format!")}this.applicationController.settingsModel.setSetting("RedirectedTerritory",null);return false},_buildGSDURI:function(d,c){var a="",b;if(typeof d==="undefined"){ovi.Logger.error("invalid gsdBaseURI passed to buildGSDURI");return null}a=d;if(typeof c!=="undefined"){for(b in c){if(c.hasOwnProperty(b)&&c[b]!==null&&c[b]!==undefined){a+="&"+b+"="+c[b]}}a=a.replace("&","?")}ovi.Logger.debug("buildGSDURI returns: "+a);return a},forceRefreshStoreConfig:function(){var a={master:false,storeConfig:true},d=false,c=this,b;if(this.get("territory")!==null){d=this.retrieveGlobalServiceDocument(a,true,function(e){ovi.Logger.debug("forceRefreshStoreConfig from latest GSD...");c.updateStoreConfigFromGSD(e)})}else{ovi.Logger.info("forceRefreshStoreConfig has no territory so cannot get storeConfig")}return d},syncForceRefreshStoreConfig:function(){var a={master:false,storeConfig:true},d=false,c=this,b;if(this.get("territory")!==null){b=this.retrieveGlobalServiceDocument(a,false);ovi.Logger.debug("forceRefreshStoreConfig from latest GSD...");this.updateStoreConfigFromGSD(b)}else{ovi.Logger.info("forceRefreshStoreConfig has no territory so cannot get storeConfig")}return true},updateStoreConfigFromGSD:function(a){if(!!a&&typeof a.workspace!=="undefined"&&typeof a.workspace[0].settings!=="undefined"){this.setStoreConfig(a.workspace[0].settings);ovi.Logger.debug("updateStoreConfigFromGSD() stored latest storeConfig settings!#####################");return true}else{ovi.Logger.debug("updateStoreConfigFromGSD() unable to determine storeConfig from Global Service Document");return false}},setStoreConfig:function(a){return this.set("storeConfig",a)},_lastSyncPoint:null,getRealTime:function(e){var a=null,b,d,f,c;e=e||false;d=this._lastSyncPoint;if(d!==null&&!!d.client_time_millis&&!!d.server_time_millis&&!e){ovi.Logger.debug("AccountModel.getRealTime() has an existing _lastSyncPoint to calculate time...")}else{ovi.Logger.warn("AccountModel.getRealTime() has no _lastSyncPoint object to calculate time. Need to initialize");if(!!this.noaAuthentication){c=this.noaAuthentication.oAuthTimeStamp();this._updateSyncPoint(c);ovi.Logger.debug("AccountModel.getRealTime() got oAuthTimeStamp: "+c)}else{f=new Date().getTime();this._updateSyncPoint(f);ovi.Logger.warn("AccountModel.getRealTime() has to assume client time! "+f)}}a=this._calculateRealTime(this._lastSyncPoint);ovi.Logger.debug("AccountModel.getRealTime() thinks the real time is: "+new Date(a).toString());return a},_updateSyncPoint:function(a){if(!!a&&(a=parseInt(a,10))>-1){this._lastSyncPoint={client_time_millis:new Date().getTime(),server_time_millis:a};return true}else{ovi.Logger.error("AccountModel._updateSyncPoint() failed with invalid value for serverTimeMillis: "+a)}return false},_calculateRealTime:function(a){var b=new Date().getTime();if(!a||typeof a.client_time_millis==="undefined"||typeof a.server_time_millis==="undefined"){ovi.Logger.error("_calculateRealTime returning null because sync_point is null");return null}b=b+(a.server_time_millis-a.client_time_millis);return b},_isStoreConfigRequired:function(c){var d,b,g,a;c=!!c;if(c){d=this.getStoreConfig("testCacheLifetimeMillis",true)}else{d=this.getStoreConfig("liveCacheLifetimeMillis",true)}try{d=parseInt(d,10)}catch(f){ovi.Logger.warn("AccountModel._checkStoreConfigExpiry reports invalid value specified for cache lifetime!");d=null}d=parseInt(d,10)||15*60*1000;g=this.getStoreConfig("cacheTime",true);a=this.getRealTime();ovi.Logger.debug("AccountModel._isStoreConfigRequired\n~~~~~~~~~~~~~~~~~~~~~~~~~\n");ovi.Logger.debug("now: "+a);ovi.Logger.debug("cacheTimestamp: "+g);ovi.Logger.debug("cacheLifetime: "+d);ovi.Logger.debug("cacheTimestamp + cacheLifetime: "+(g+d));ovi.Logger.debug("~~~~~~~~~~~~~~~~~~~~~~~~~\n");if(b!==null&&a<(g+d)){ovi.Logger.debug("AccountModel._isStoreConfigRequired says cached storeConfig is still valid... returning false");return false}ovi.Logger.debug("AccountModel._isStoreConfigRequired returning true. stale or missing storeConfig in cache");return true},getStoreConfig:function(c,b){var d=null,a;a=this.get("storeConfig")||null;c=c||null;b=b||false;if(c){if(a!==null&&a.hasOwnProperty(c)){ovi.Logger.debug("retrieved config from accountModel with key: "+c);d=a[c];if(!b&&this._isStoreConfigRequired(false)){ovi.Logger.info("#####################################storeConfig cacheTime exceeded, forcing update...");this.forceRefreshStoreConfig()}}else{d=this.applicationController.settingsModel.getDefaultStoreConfigValue(c);ovi.Logger.debug("retrieved config from defaults: "+d+" with key: "+c)}ovi.Logger.debug("retrieved config from accountModel: "+d)}else{a=this.applicationController.settingsModel.getConfig("storeConfig");if(a!==null){d=a;if(d.hasOwnProperty("cacheTime")){ovi.Logger.debug("retrieved config from accountModel with cacheTime: "+d.cacheTime);if(!b&&this._isStoreConfigRequired(false)){ovi.Logger.info("#####################################storeConfig cacheTime exceeded, forcing update...");this.forceRefreshStoreConfig()}}ovi.Logger.debug("returning whole storeConfig")}}ovi.Logger.debug("getStoreConfig returning: "+d);return d},noa:function(){var c=this.get("consumerKey"),b=this.get("consumerSecret");try{if(c!==null&&b!==null){this.noaAuthentication=new ovi.service.sso.NoaAuthentication();this.noaAuthentication.initialise(c,b);ovi.Logger.debug("NoaAuth Initialised successfully");this.set("SSOActive",true)}else{ovi.Logger.warn("Account Model could not retrieve consumerKey or consumerSecret! cannot authenticate");return false}}catch(a){ovi.Logger.error("cannot initialise ovi.service.sso.NoaAuthentication, account managed functionality not activated for this session! message: "+a)}if(!this.noaAuthentication){ovi.Logger.warn("Unable to load ovi sso, loading stub!!!");ovi.require("music.download.stub.noaStub");this.noaAuthentication=new music.download.stub.noaStub();this.noaAuthentication.initialise(c,b);this.set("SSOActive",true)}return true},isAuthenticated:function(){ovi.Logger.debug("AUTHENTICATION OBJECT: "+this.noaAuthentication);if(this.get("SSOActive")===true){return this.noaAuthentication.isAuthenticated()}else{return false}},hasSsoAccount:function(){var a=false,b;if(this.get("SSOActive")===true){b=this.noaAuthentication.account();ovi.Logger.debug("hasSsoAccount "+this.noaAuthentication.account()+" username "+b.userName);if(b&&b.userName&&b.userName!==""){a=true}}return a},isPasswordRemembered:function(){var a=false;if(this.get("SSOActive")===true){a=this.noaAuthentication.isPasswordRemembered();ovi.Logger.debug("isPasswordRemembered "+a)}return a},getSSOAccountDetails:function(){if(this.isSignedIn()){var a=this.noaAuthentication.account();return a}else{return false}},isSignedIn:function(){var a;if(this.get("SSOActive")===true){try{a=this.noaAuthentication.token()}catch(b){ovi.Logger.debug("isSignedIn false, fetching token failed with: "+b);return false}if(a===null||a===""||typeof a==="undefined"){return false}return true}else{return false}},logOut:function(){if(this.noaAuthentication.isAuthenticated()){this.noaAuthentication.signOut();ovi.Logger.debug("SSO session closed")}else{ovi.Logger.debug("No SSO session currently active")}},removeAccountCache:function(){this.noaAuthentication.removeCachedAccount()}});