ovi.require("music.streaming.events");ovi.require("music.streaming.BufferingTimer");ovi.require("music.streaming.EventSender");ovi.require("music.streaming.ProgressTracker");ovi.require("music.streaming.ServiceProviderFactory");ovi.require("music.streaming.TrackList");ovi.provide("music.streaming.Engine");ovi.declare("music.streaming.Engine",{Statics:{MAX_TRACK_LENGTH_IN_MILLIS:30*1000,MAX_TRACK_LENGTH_BUFFER_IN_MILLIS:1000},Mixins:[ovi.EventSource],initialize:function initialize(){this._createBufferingTimer();this._createProgressTracker();this._trackList=new music.streaming.TrackList();this._eventSender=new music.streaming.EventSender(ovi.bind(this,this._getCurrentTrackData),ovi.bind(this,this.fireEvent));this._service=music.streaming.ServiceProviderFactory.createServiceForCurrentPlatform({onPlay:ovi.bind(this,this._onPlaying),onStop:ovi.bind(this,this._onStopComplete),onBuffering:ovi.bind(this,this._onBuffering),onComplete:ovi.bind(this,this._onTrackComplete),onError:ovi.bind(this,this._onError)})},play:function play(b){ovi.Logger.debug("music.streaming.Engine.play() BEGIN");this.stop();var a=this._getTracksFromEvent(b);this._playTracks(a);ovi.Logger.debug("music.streaming.Engine.play() END")},stop:function stop(){ovi.Logger.debug("music.streaming.Engine.stop() BEGIN");if(this._trackList.hasCurrentTrack()){ovi.Logger.debug("music.streaming.Engine.stop() not stopped, stopping...");this._service.stop()}ovi.Logger.debug("music.streaming.Engine.stop() END")},getCurrentlyPlayingData:function getCurrentlyPlayingData(){return this._getCurrentTrackData()},_getTracksFromEvent:function _getTracksFromEvent(b){var a=[];if(b&&b.data&&b.data.trackList){a=b.data.trackList}return a},_playTracks:function _playTracks(a){ovi.Logger.debug("music.streaming.Engine._playTracks(): "+a);if(this._trackListIsInvalid(a)){ovi.Logger.debug("music.streaming.Engine._playTracks() INVALID_TRACKLIST ");this._sendEvent("ERROR_TRACK");return}if(this._trackList.hasCurrentTrack()){this._queueTracksUntilStopCompletes(a);return}this._trackList.setTracks(a);this._sendEvent("PLAYLIST_START");this._startPlayback();ovi.Logger.debug("music.streaming.Engine._playTracks() END")},_startPlayback:function _startPlayback(){this._currentDuration=0;this._sendEvent("TRACK_START");this._service.play(this._trackList.getCurrentTrackUri())},_onPlaying:function _onPlaying(){this._sendEvent("PLAYING")},_onBuffering:function _onBuffering(a){this._sendEvent("BUFFERING")},_onProgress:function _onProgress(a){this._currentDuration=a;if(this._durationHasExceededMaximum()){this._stopTooLongTracksPlaybackAndStartNext()}else{this._sendEvent("PROGRESS")}},_onStopComplete:function _onStopComplete(){ovi.Logger.debug("music.streaming.Engine._onStopComplete()");this._sendEvent("TRACK_END");this._onPlayListComplete();if(this._queuedTracks){this._playQueuedTracks()}},_onTrackComplete:function _onTrackComplete(){ovi.Logger.debug("music.streaming.Engine._onTrackComplete()");this._sendEvent("TRACK_END");if(this._trackList.hasMoreTracks()){this._playNext()}else{this._onPlayListComplete()}},_onPlayListComplete:function _onPlayListComplete(){ovi.Logger.debug("music.streaming.Engine._onPlayListComplete()");this._sendEvent("PLAYLIST_END");this._resetEngine()},_onError:function _onError(a){ovi.Logger.error("music.streaming.Engine._onError("+a+")");if(this._trackList.hasMoreTracks()){this._sendEvent("TRACK_END");this._playNext()}else{this._sendEvent(this._getErrorEvent(a));this._resetEngine()}},_createBufferingTimer:function _createBufferingTimer(){var b=new music.streaming.BufferingTimer(this,this._onError);var a=music.streaming.events.playback;this.addEventHandler(a.TRACK_START,b.start,b);this.addEventHandler(a.BUFFERING,b.start,b);this.addEventHandler(a.TRACK_END,b.clear,b);this.addEventHandler(a.PLAYING,b.clear,b);this.addEventHandler(a.ERROR_TRACK,b.clear,b);this.addEventHandler(a.ERROR_CONNECTION,b.clear,b)},_createProgressTracker:function _createProgressTracker(){this._currentDuration=0;var b=new music.streaming.ProgressTracker(this,this._onProgress);var a=music.streaming.events.playback;this.addEventHandler(a.PLAYING,b.resume,b);this.addEventHandler(a.BUFFERING,b.pause,b);this.addEventHandler(a.TRACK_END,b.reset,b);this.addEventHandler(a.ERROR_TRACK,b.reset,b);this.addEventHandler(a.ERROR_CONNECTION,b.reset,b)},_playNext:function _playNext(){if(this._trackList.hasMoreTracks()){this._trackList.setupNextTrack();ovi.Logger.debug("music.streaming.Engine._playNext() setup next track");this._startPlayback()}},_durationHasExceededMaximum:function _durationHasExceededMaximum(){var b=music.streaming.Engine;var a=b.MAX_TRACK_LENGTH_IN_MILLIS+b.MAX_TRACK_LENGTH_BUFFER_IN_MILLIS;return this._currentDuration>a},_stopTooLongTracksPlaybackAndStartNext:function _stopTooLongTracksPlaybackAndStartNext(){ovi.Logger.debug("music.streaming.Engine._stopTooLongTracksPlaybackAndStartNext()");this._service.stop();this._playNext()},_getErrorEvent:function _getErrorEvent(a){if(a.code){ovi.Logger.error("music.streaming.Engine._getErrorEvent() code: "+a.code+", message: "+a.message)}if(a.code===a.NOT_SUPPORTED_ERR||a.code===a.DATA_OUT_OF_RANGE_ERR){return"ERROR_TRACK"}return"ERROR_CONNECTION"},_trackListIsInvalid:function _trackListIsInvalid(a){return typeof a!=="object"||!a.length||!a[0].getId},_queueTracksUntilStopCompletes:function _queueTracksUntilStopCompletes(a){ovi.Logger.debug("music.streaming.Engine._queueTracksUntilStopCompletes()");this._queuedTracks=a},_playQueuedTracks:function _playQueuedTracks(){ovi.Logger.debug("music.streaming.Engine._playQueuedTracks()");this._playTracks(this._queuedTracks);delete this._queuedTracks},_resetEngine:function _resetEngine(){ovi.Logger.debug("music.streaming.Engine._resetEngine()");this._trackList.reset();this._currentDuration=0},_sendEvent:function _sendEvent(a){this._eventSender.send(a)},_getCurrentTrackData:function _getCurrentTrackData(){return this._trackList.getCurrentTrackData(this._currentDuration)}});